// Constants for EMU 10k2 (SB Audigy)
/*
 * This file is part of Open Sound System
 *
 * Copyright (C) 4Front Technologies 1996-2008.
 *
 * This software is released under the BSD license.
 * See the COPYING file included in the main directory of this source
 * distribution for the license terms and conditions
 */

// Sends

.send SEND_L 0. send SEND_R 1. send SEND_SL 2. send SEND_SR 3. send SEND_C 4.
  send SEND_W 5. send SEND_RL 6. send SEND_RR 7
// Raw S/PDIF output stream
  .send SPDIF_L 20. send SPDIF_R 21
// Inputs
  .input AC97IN_L 0.i nput AC97IN_R 1.i nput CDSPDIFIN_L 2.i nput CDSPDIFIN_R 3.i nput GPSPDIFIN_L 4	// TOSLink
  .input GPSPDIFIN_R 5.i nput CXSPDIFIN_L 6	// LiveDrive (Coax S/PDIF input)
  .input CXSPDIFIN_R 7.i nput MICIN_L 8	// LiveDrive (Line/Mic In 1)
  .input MICIN_R 9.i nput ANACD_L 10	// Analog CD input?
  .input ANACD_R 11.i nput AUXIN_L 12	// LiveDrive (Line/Mic 2)
  .input AUXIN_R 13
// Outputs
/*
audigy's Mic In is not connected to AC97;
known Audigy output map:
[digital/analog]:
0x60, 0x68 - front left
0x61, 0x69 - front right
0x66, 0x6e - rear left
0x67, 0x6f - rear right
0x62, 0x6a - center
0x63, 0x6b - subwoofer

0x7c,0x7d - in Creative DSP code this is the same as Digital Front; can be
LiveDrive SPDIF out
*/
  .output SPDOUT1_L 0. output SPDOUT1_R 1. output DCENTER 2	// Digital Center channel
  .output DLFE 3		// Digital LFE
  .output HEADPH_L 4		// LiveDrive headphone out
  .output HEADPH_R 5. output DSURR_L 6	// Surround output
  .output DSURR_R 7. output FRONT_L 8. output FRONT_R 9. output ACENTER 10	// Analog center channel
  .output ALFE 11		// Analog LFE output
  .output SURR_L 14		// Surround output
  .output SURR_R 15. output AC97_L 16	// Send to the AC97 front channel
  .output AC97_R 17. output ADC_L 22	// Send to the ADC recording channel
  .output ADC_R 23. output MICREC_L 24	// Send to the microphone recording buffer
  .output MICREC_R 25		// ??????? (maybe not in use at all)
